var Birt = (function () {
    var _this;

    var rptDesignJsonData;  //报表的json数据

    var $birt;              //birt报表整个区域
    var $reports;           //报表区域
    var $menus;             //文件列表，菜单区域

    function Birt(designJsonData) {
        _this = this;
        rptDesignJsonData = designJsonData;
    }

    Birt.prototype.file_name = "";      //birt报表文件名称

    /**
     * 开始加载
     */
    Birt.prototype.run = function () {
        _this.onCreate();
        _this.getRetDesign();
        _this.getMenus();
    };

    /**
     * 被创建时
     */
    Birt.prototype.onCreate = function () {
        $birt = $('.birt');

        $menus = $birt.find(".birt-menus");

    };

    /**
     * 获取报表数据
     * @param rptDesignName
     */
    Birt.prototype.getRetDesign = function (rptDesignName) {
        _this.file_name = rptDesignName || $birt.data('rptdesign');

        $.birtLoading();
        $.ajax(
            {
                url: '/birt/api?_report={0}'.format(_this.file_name),
                type: 'GET',
                success: function (data) {
                    $.birtLoading('hide');
                    $birt.append(data);
                    $reports = $birt.find(".birt-reports");
                    $reports.find(".birt-line-charts").each(function () {
                        _this.showLineChart($(this).data('line-chart'));
                    });

                },
                error: function (data) {
                    $.birtLoading('hide');
                }
            }
        );
    };

    /**
     * 获取报表的目录结构
     */
    Birt.prototype.getMenus = function () {
        var menus = _this.getMenusFromCache();
        if (menus) {
            $birt.prepend(menus);
            $birt.find("ul.birt-menus li.item").removeClass('active');
            $birt.find("ul.birt-menus li.item[data-rptdesign='{0}']".format(_this.file_name.replace(".rptdesign",""))).addClass('active');

            return;
        }
        $.ajax(
            {
                url: '/birt/api/menus?current='+_this.file_name.replace(".rptdesign", ""),
                type: 'GET',
                success: function (data) {
                    console.log(data);
                    $birt.prepend(data);
                    _this.putMenusToCache(data);
                },
                error: function (data) {
                }
            }
        );
    };

    /**
     * 从缓存中获取菜单列表
     */
    Birt.prototype.getMenusFromCache = function () {
        var menus = localStorage.getItem("birt_menus");
        console.log(menus);
        return menus;
    };

    /**
     * 将菜单数据写入缓存
     * @param menus
     */
    Birt.prototype.putMenusToCache = function (menus_html) {
        localStorage.setItem("birt_menus", menus_html);
    };


    Birt.prototype.showLineChart = function (lineChart) {
        $reports.append("<div id='report_{0}'></div>".format(lineChart.id));
        new Highcharts.Chart({
            chart: {
                renderTo: "report_{0}".format(lineChart.id),
                plotBackgroundColor: null,
                plotBorderWidth: null,
                defaultSeriesType: 'spline'
            },
            title: {
                text: lineChart.title
            },
            xAxis: {
                categories: lineChart.x_data,
                labels: {
                    rotation: -45, //字体倾斜
                    align: 'right',
                    style: {font: 'normal 13px 宋体'}
                }
            },
            yAxis: {
                title: {
                    text: "销量/元"
                }
            },

            series: lineChart.series
        });
    };
    return Birt;
})();
