require "birt/routing"
require "birt/version"
require 'rails'
require "birt/engine"
require 'rexml/document'
require 'base64'
require 'pry'
require 'mysql2'


%w{ controllers helpers views}.each do |dir|
  path = File.join(File.dirname(__FILE__), 'app', dir)
  $LOAD_PATH << path
  ActiveSupport::Dependencies.autoload_paths << path
  ActiveSupport::Dependencies.autoload_once_paths.delete(path)
end
Dir.glob("#{File.dirname(__FILE__)}/birt/core/*.rb") { |f| require f }
Dir.glob("#{File.dirname(__FILE__)}/birt/core/table/*.rb") { |f| require f }
Dir.glob("#{File.dirname(__FILE__)}/birt/core/chart/*.rb") { |f| require f }


module Birt
  module_function

  def birt(rptdesign_name)
    "<div class=\"birt\" data-rptdesign=\"#{rptdesign_name}.rptdesign\"></div>"
  end

  #获取报表的目录结构
  def menus
    Dir.glob("./reports/*.rptdesign").inject([]) { |acc, f|
      names = REXML::Document.new(File.read(f)).root.get_elements("/report/text-property[@name='displayName']")
      display_name = names[0].text if names && names[0]
      file_name = f.split('/').last.split(".").first
      acc << {
          file_name: file_name,
          display_name: display_name || file_name
      }; acc
    }
  end
end
